// my vdpol #2
// chaotic trajectory with sliders
// code frags: xforms, vdpol, coloring

//GLOBALS ======================================

var slidera;
var sliderb;
var a; // to hold slider value, this is R, the reynold's number, 1 to 50
var b; // to hold slider value, usually 8/3
var runtime = 0.0; // init time along trajectory
var dt = 0.1; // euler timestep
var finaltime = 1.0; // when to stop plot
var dwell = 1.5; // time to decay tanssient
var canvas1;

// 3D screen coords, (0,0,0) is in the center)
var xmin = -250;
var xmax = 250;
var ymin = -250;
var ymax = 250;
var zmin = -250;
var zmax = 250;
var xdelta = xmax - xmin;
var ydelta = ymax - ymin;
var zdelta = zmax - zmin;

// MATH COORDS (u, v, w)
//init conditions
var u0 = 5; 
var v0 = 5;
var w0 = 25.0;
// the lorenz domain (cubical)
var umin = -80;
var umax = 80;
var vmin = -80;
var vmax = 80;
var wmin = -30;
var wmax = 130;
var udelta = umax - umin;
var vdelta = vmax - vmin;
var wdelta = wmax - wmin;
// math coords for trajectory with init values
var unow = u0;
var vnow = v0;
var wnow = w0;
var unext = unew(unow, vnow, wnow);
var vnext = vnew(unow, vnow, wnow);
var wnext = wnew(unow, vnow, wnow);
// CANVAS COORDS (x, y, z)
// canvas size, (0, 0) to (500, 500)
var h = 500;
var w = 500;
// canvas coords for trajectry
var xnow = xcanvas(unow);
var ynow = ycanvas(vnow);
var znow = zcanvas(wnow);
var xnext = xcanvas(unext);
var ynext = ycanvas(vnext);
var znext = zcanvas(wnext);

function plot0() {
	fill(255, 0, 0); // red
	translate(100, 100, 100);
	sphere(100);
}

// drawing routines
function plot() {
	// reset inits
	unow = u0; 
	vnow = v0;
	wnow = w0;
	//plot init point
	// convert
	xnow = xcanvas(unow);
	ynow = ycanvas(vnow);
	znow = zcanvas(wnow);
	
//	x0 = xcanvas(u0);
//	y0 = ycanvas(v0);
//	z0 = zcanvas(w0);
	fill(255, 255, 0); // yellow

	// now iterate
	var i = 0;
	for (i = 0; i < 10000; i++){
		// iterate
		unext = unew(unow, vnow, wnow);
		vnext = vnew(unow, vnow, wnow);
		wnext = wnew(unow, vnow, wnow);
		// convert
		xnow = xcanvas(unow);
		ynow = ycanvas(vnow);
		znow = zcanvas(wnow);
		// display
		push();
		rotateY(frameCount * 0.1);
		translate(xnow, ynow, znow);
		// translate(x0 + i, y0 + i, z0 + i);
		sphere(2);
		pop();
//		//swappo
		unow = unext;
		vnow = vnext;
		wnow = wnext;
	}
}

// begin usual sketch code ======================
function setup() {
	// set canvas
	canvas1 = createCanvas(w, h, WEBGL);
	background(200); // 20% gray
	//slidera
	//args = (min, max, default value, step size) last = 0 for continuous motion
	slidera = createSlider(0.0, 120.0, 28, 0.1); // floating point slider
	slidera.position(20, h + 140); // args = upper left corner (x, y)
	slidera.style('width', '500px');
//	sliderb
//	sliderb = createSlider(0.0, 5.0, 2.66, 0.1); // floating point slider
//	sliderb.position(20, h + 180); // args = upper left corner (x, y)
//	sliderb.style('width', '500px');
//	sliderd dwell
//	sliderd = createSlider(0.0, 20.0, 5.0, 1.0); // floating point slider
//	sliderd.position(20, h + 220); // args = upper left corner (x, y)
//	sliderd.style('width', '500px');
} // end setup

function draw() {
	background(200); // clear the canvas to gray
	a = slidera.value(); // update coeffs
	// b = sliderb.value();
	// dwell = sliderd.value();
	plot(); // draw trajectory
}

// end of sketch
